﻿
procedure Form1_Label24_OnClick (Sender: TObject);
begin
    OpenURL('http://myvisualdatabase.com'); 
end;

procedure frmQBookIn_gridBooks_OnKeyDown (Sender: TObject; var Key: Word; Shift, Alt, Ctrl: boolean);
var
    i, c: integer;
begin
    if Ctrl and (Key=65) then
    begin
        c := frmQBookIn.gridBooks.RowCount-1;
        for i := 0 to c do frmQBookIn.gridBooks.Cell[0,i].AsBoolean := True;
    end;
end;


procedure frmQInvoice_bQInvoicePrint_OnClick (Sender: TObject; var Cancel: boolean);
begin
    frmQInvoice.bOK.Click;
    frmQInvoice.bQInvoicePrint.dbFilter := 'invoice.id='+IntToStr(frmQInvoice.bOK.Tag);
end;

procedure Form1_bInvoicesPrint_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if Form1.gridInvoices.dbItemID = -1 then
    begin
        ShowMessage('You should select a invoice.');
        Cancel := true;
    end;
end;

procedure frmQInvoice_bOK_OnClick (Sender: TObject; var Cancel: boolean);
var
    i, c: integer;
    idService, idUser, sPrice, sQty: string;
    idInvoice: integer;
    sInvNumber: string;
begin
    sInvNumber := SQLExecute('SELECT IFNULL(MAX(record_count), 0)+1 FROM invoice');
    if Application.User.id<>-1 then idUser := IntToStr(Application.User.id) else idUser := 'NULL';
                                              
    SQLExecute('INSERT INTO invoice (record_count, datetime, id__user) VALUES ('+sInvNumber+', datetime(''now'', ''localtime''),'+idUser+')');
    idInvoice := Last_Insert_id;
    frmQInvoice.bOK.Tag := idInvoice;

    c := frmQInvoice.gridServices.RowCount-1;
    for i := 0 to c do
    begin
        if frmQInvoice.gridServices.Cell[2,i].AsInteger > 0 then // Qty
        begin
            sQty := frmQInvoice.gridServices.Cells[2,i];
            idService := IntToStr(frmQInvoice.gridServices.Row[i].ID);
            sPrice := FloatToStr(frmQInvoice.gridServices.Cell[1,i].AsFloat);
            sPrice := ReplaceStr(sPrice, ',', '.');
            SQLExecute('INSERT INTO invitems (id_invoice, id_service, price, qty) VALUES('+ IntToStr(idInvoice) +','+ idService+','+sPrice+','+sQty+')');
        end;
    end;
    UpdateDatabase('invoice');
    frmQInvoice.Close;
end;

procedure frmQInvoice_gridServices_OnCellClick (Sender: TObject; ACol, ARow: Integer);
begin
    // price, qty, total
    if ACol = 4 then
        frmQInvoice.gridServices.Cell[2,ARow].AsInteger := frmQInvoice.gridServices.Cell[2,ARow].AsInteger + 1;

    if (ACol = 5) and (frmQInvoice.gridServices.Cell[2,ARow].AsInteger > 0) then
        frmQInvoice.gridServices.Cell[2,ARow].AsInteger := frmQInvoice.gridServices.Cell[2,ARow].AsInteger - 1;

    frmQInvoice.gridServices.Cell[3,ARow].AsFloat := frmQInvoice.gridServices.Cell[1,ARow].AsFloat * frmQInvoice.gridServices.Cell[2,ARow].AsInteger;
    frmQInvoice.gridServices.CalculateFooter;
end;

procedure frmQInvoice_gridServices_OnChange (Sender: TObject);
var
    i, c: integer;
begin
    c := frmQInvoice.gridServices.RowCount-1;
    frmQInvoice.gridServices.BeginUpdate;
    for i := 0 to c do
    begin
        frmQInvoice.gridServices.Cell[4,i].Color := rgb(200, 255, 255);
        frmQInvoice.gridServices.Cell[5,i].Color := rgb(255, 200, 255);
        frmQInvoice.gridServices.Cell[4,i].FontStyle := fsBold;
        frmQInvoice.gridServices.Cell[5,i].FontStyle := fsBold;
    end;
    frmQInvoice.gridServices.EndUpdate;
end;

procedure frmItem_cbService_OnChange (Sender: TObject);
begin
    if frmItem.dbAction = 'NewRecord' then
    begin
        if frmItem.cbService.dbItemID <> -1 then
            frmItem.edPrice.Value := SQLExecute('SELECT price FROM service WHERE id='+ frmItem.cbService.sqlValue)
        else
            frmItem.edPrice.Text := '';
    end;
end;

procedure frmInvoice_bSave_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if (frmInvoice.dbAction='ShowRecord') and (Application.User.id <> -1) and (not Application.User.is_admin) and (frmInvoice.cbUser.dbItemID <> Application.User.id) then
    begin
        ShowMessage('Only owner of the record can change it.');
        Cancel := True;
    end;
end;

procedure frmInvoice_OnShow (Sender: TObject; Action: string);
begin
    if (Action='NewRecord') and (Application.User.id <> -1) then frmInvoice.cbUser.dbItemID := Application.User.id;
end;

procedure frmQBookIn_bReturnBook_OnClick (Sender: TObject; var Cancel: boolean);
var
    i, c: integer;
    idBook, idPerson, idAction, idUser, sComment: string;
begin
    c := frmQBookIn.gridBooks.RowCount-1;
    for i := 0 to c do
    begin
        if frmQBookIn.gridBooks.Cell[0,i].AsBoolean then
        begin
            //idBook := SQLExecute('SELECT IFNULL(id_book, -1) FROM history WHERE id='+IntToStr(frmQBookIn.gridBooks.Row[i].ID));
            idBook := IntToStr(frmQBookIn.gridBooks.Row[i].ID);
            if idBook<>'-1' then
            begin
                idPerson := frmQBookIn.cbPerson.sqlValue;
                sComment := frmQBookIn.gridBooks.Cells[3,i];
                if sComment <> '' then sComment := ''''+escape_special_characters(sComment)+'''' else sComment := 'NULL';

                idAction := '2'; // Returned status
                if frmQBookIn.gridBooks.Cell[4,i].AsBoolean then idAction := '3'; // Damaged status
                if frmQBookIn.gridBooks.Cell[5,i].AsBoolean then idAction := '4'; // Losted status

                if Application.User.id<>-1 then idUser := IntToStr(Application.User.id) else idUser := 'NULL';

                SQLExecute('INSERT INTO history (id_book, datetime, id_action, id_person, id__user, comment) VALUES('+idBook+', datetime(''now'', ''localtime''), '+idAction+', '+idPerson+','+idUser+','+sComment+')');
            end;
        end;
    end;
    UpdateDatabase('history');
    UpdateDatabase('book');
    frmQBookIn.Close;
end;

procedure frmQBookIn_gridBooks_OnChange (Sender: TObject);
begin
    frmQBookIn.gridBooks.Columns[3].Options := frmQBookIn.gridBooks.Columns[3].Options + coEditing;
end;

procedure frmQBookIn_cbPerson_OnKeyUp (Sender: TObject; var Key: Word; Shift, Alt, Ctrl: boolean);
begin
    // стрелки вверх и вниз
    //if (Key=38) or (Key=40) then
    //    if frmQBookIn.cbPerson.dbItemID = -1 then frmQBookIn.gridBooks.ClearRows else frmQBookIn.bSearchTakenBook.Click;
end;

procedure frmQBookIn_cbPerson_OnChange (Sender: TObject);
begin
    frmQBookIn.edPerson.Value := frmQBookIn.cbPerson.dbItemID;
    if frmQBookIn.edPerson.Value = -1 then frmQBookIn.edPerson.Text := '';

    if frmQBookIn.cbPerson.dbItemID = -1 then frmQBookIn.gridBooks.ClearRows else frmQBookIn.bSearchTakenBook.Click;                            
end;

procedure frmQBookIn_OnShow (Sender: TObject; Action: string);
begin
    frmQBookIn.cbPerson.dbItemID := -1;
    frmQBookIn.gridBooks.ClearRows;
end;

procedure frmQBook_gridBooks_OnChange (Sender: TObject);
begin
    frmQBookOut.gridBooks.Columns[2].Options := frmQBookOut.gridBooks.Columns[2].Options + coEditing;
end;

procedure frmQBook_OnShow (Sender: TObject; Action: string);
begin
    frmQBookOut.cbPerson.dbItemID := -1;
    frmQBookOut.gridBooks.dbItemID := -1;
    frmQBookOut.gridBooks.ClearRows;
end;

procedure frmQBook_bGiveOut_OnClick (Sender: TObject; var Cancel: boolean);
var
    i, c: integer;
    idBook, idPerson, idUser, sComment: string;
begin
    c := frmQBookOut.gridBooks.RowCount-1;
    for i := 0 to c do
    begin
        idBook := IntToStr(frmQBookOut.gridBooks.Row[i].ID);
        idPerson := frmQBookOut.cbPerson.sqlValue;
        sComment := frmQBookOut.gridBooks.Cells[2,i];
        if sComment <> '' then sComment := ''''+escape_special_characters(sComment)+'''' else sComment := 'NULL';
        if Application.User.id<>-1 then idUser := IntToStr(Application.User.id) else idUser := 'NULL';
        SQLExecute('INSERT INTO history (id_book, datetime, id_action, id_person, id__user, comment) VALUES('+idBook+', datetime(''now'', ''localtime''), 1, '+idPerson+','+idUser+','+sComment+')');
    end;
    UpdateDatabase('history');
    UpdateDatabase('book');
    frmQBookOut.Close;
end;

procedure frmQBook_bDelete_OnClick (Sender: TObject; var Cancel: boolean);
begin
    frmQBookOut.gridBooks.DeleteRow(frmQBookOut.gridBooks.SelectedRow);
    frmQBookOut.gridBooks.CalculateFooter;
end;

procedure frmQBook_cbBook_OnKeyUp (Sender: TObject; var Key: Word; Shift, Alt, Ctrl: boolean);
begin
    if Key=13 then
    begin
        frmQBookOut.gridBooks.AddRow();
        frmQBookOut.gridBooks.Cells[0,frmQBookOut.gridBooks.LastAddedRow]:= SQLExecute('SELECT title FROM book WHERE id='+frmQBookOut.cbBook.sqlValue);
        frmQBookOut.gridBooks.Cells[1,frmQBookOut.gridBooks.LastAddedRow]:= SQLExecute('SELECT author FROM book WHERE id='+frmQBookOut.cbBook.sqlValue);
        frmQBookOut.gridBooks.Row[frmQBookOut.gridBooks.LastAddedRow].ID := frmQBookOut.cbBook.dbItemID;
        frmQBookOut.cbBook.dbItemID := -1;
        frmQBookOut.gridBooks.CalculateFooter;
    end;
end;


procedure frmPersonHistory_bSave_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if (frmPersonHistory.dbAction='ShowRecord') and (Application.User.id <> -1) and (not Application.User.is_admin) and (frmPersonHistory.cbUser.dbItemID <> Application.User.id) then
    begin
        ShowMessage('Only owner of the record can change it.');
        Cancel := True;
    end;
end;

procedure frmHistory_bSave_OnClick (Sender: TObject; var Cancel: boolean);
begin
    if (frmHistory.dbAction='ShowRecord') and (Application.User.id <> -1) and (not Application.User.is_admin) and (frmHistory.cbUser.dbItemID <> Application.User.id) then
    begin
        ShowMessage('Only owner of the record can change it.');
        Cancel := True;
    end;
end;


procedure frmPersonHistory_OnShow (Sender: TObject; Action: string);
begin
    if (Action='NewRecord') and (Application.User.id <> -1) then frmPersonHistory.cbUser.dbItemID := Application.User.id;
end;

procedure frmHistory_OnShow (Sender: TObject; Action: string);
begin
    if (Action='NewRecord') and (Application.User.id <> -1) then frmHistory.cbUser.dbItemID := Application.User.id;
end;

procedure Form1_bSendEmail_OnClick (Sender: TObject; var Cancel: boolean);
var
    email: string;
    books: string;
    i, c: integer;
begin
    books := 'Hello.%0D%0A%0D%0AReminder to return books:%0D%0A%0D%0A';
    c := Form1.gridOutdatedBooks.RowCount-1;
    for i := 0 to c do books := books + IntToStr(i+1)+'. ' + Form1.gridOutdatedBooks.Cells[0, i] + '%0D%0A';

    email := SQLExecute('SELECT person.email FROM history LEFT OUTER JOIN person ON person.id=history.id_person WHERE history.id='+Form1.gridOutdated.sqlValue);
    OpenFile('mailto:'+email+'?Subject=Library&Body='+books);
end;

procedure Form1_gridOutdated_OnChange (Sender: TObject);
var
    i, c: integer;
begin
    Form1.gridOutdated.BeginUpdate;
    c := Form1.gridOutdated.RowCount-1;
    for i := c downto 1 do
    begin
        if Form1.gridOutdated.Cells[0,i]= Form1.gridOutdated.Cells[0,i-1] then Form1.gridOutdated.RowVisible[i] := false;
    end;
    Form1.gridOutdated.EndUpdate;
end;

procedure Form1_gridOutdated_OnCellClick (Sender: TObject; ACol, ARow: Integer);
var
    idPerson: integer;
begin
    idPerson := SQLExecute('SELECT id_person FROM history WHERE id='+Form1.gridOutdated.sqlValue);
    Form1.edOutdatedPersonID.Value := idPerson;
    Form1.bOutdatedBooks.Click;
end;

procedure Form1_bSearchOutdated_OnClick (Sender: TObject; var Cancel: boolean);
begin
    Form1.dtOutdated.DateTime := Now - Trunc(Form1.edOutdatedDays.Value);
end;

procedure Form1_cbBookStatus_OnChange (Sender: TObject);
begin
    Form1.edBookStatus.Value := Form1.cbBookStatus.dbItemID;
    if Form1.edBookStatus.Value = -1 then Form1.edBookStatus.Text := '';
end;

procedure Form1_OnShow (Sender: TObject; Action: string);
begin
    Form1.bSearchPerson.Click;
    Form1.bSearchBook.Click;
    Form1.bSearchHistory.Click;
    Form1.bSearchOutdated.Click;
end;



{

°    Catalogue all library books (Tile off book, Author of book, Rack / shelve no, subject, Category)
°    Add photo of book.
°    Reminder when a book is late.
°    Who taken a book out (date and time).
°    When book was returned.
°    Search the system for any book (must show info if the book has been taken out)
°    Email user when a book is late.
°    Backup dbase.
°    Record  damage or lost book.
°    Report generation.
°    User info (ID Card number, Address, Phone number, email address, photo.


1. Admin logon page so staff can logon to the system.
2. to email late user so that if the click on the email address it opens outlook, Gmail if possible.
3. To be able to print reports.
4. To be able to print invoice for any user who prints (they want to charge about 2c per page that student prints out)
5. To be able to print a report of users and what books they have taken, returned, damaged and late.



1, Printing reports on books due, books out, books late, books in library
2, Ability to print invoices.
3, Ability to maximize screens panes.
4, Ability to assign user who take out books with ID that it can be scanned using barcode scanner, so when they take out or return a book we can just scan into the system.
5, Ability to scan books into system using a barcode scanner.
5, section to add library admin users (I need name, phone number, photo and address for admin users).


}

begin

end.
